<?
/*
    dividuums PHPgzip 0.1
    Copyright (c) 2000 Florian Wesch <php@dividuum.de>. All Rights Reserved.

    Permission to use, copy, modify, and distribute this software
    and its documentation for any purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies.

    Of course, this soft is provided "as is" without express or implied
    warranty of any kind.
*/


function gz_start() 
  {
    global $HTTP_SERVER_VARS,$gz_possible;
    $gz_possible = isset($HTTP_SERVER_VARS["HTTP_ACCEPT_ENCODING"]) && 
                   eregi("gzip",$HTTP_SERVER_VARS["HTTP_ACCEPT_ENCODING"]);

    if ($gz_possible) { Header("Content-Encoding: gzip");
			Header("X-Compressed-by: PHPgzip");
			ob_start();
		      }
  }
	

function gz_end()
  {
    global $gz_possible;
    if (!$gz_possible) return;
	
    $buffer = ob_get_contents();
    ob_end_clean();
    $time = time();
    $gzipheader = sprintf("%c%c%c%c%c%c%c%c%c%c",31,139,8,0,
                          ($time & (0xff)),
                          ($time & (0xff<<8))>>8,
                          ($time & (0xff<<16))>>16,
                          ($time & (0xff<<24))>>24,		 
                          0,3);
	
    // $buffer.="PHPgzip stats: ".strlen($buffer)." => ".strlen(gzcompress($buffer));

    $payload = gzcompress($buffer);
    // WTF?
    $payload = substr($payload,2,strlen($payload)-6);


    $crc=crc32($buffer);
    $len=strlen($buffer);

    $payloadfooter = sprintf("%c%c%c%c%c%c%c%c", 
                             ($crc & (0xff)),            /*crc32*/
                             ($crc & (0xff<<8))>>8,
                             ($crc & (0xff<<16))>>16,
                             ($crc & (0xff<<24))>>24, 
                             ($len & (0xff)),            /*len*/
                             ($len & (0xff<<8))>>8,
                             ($len & (0xff<<16))>>16,
                             ($len & (0xff<<24))>>24);
		
    echo $gzipheader;
    echo $payload;
  };

?>